c##############################################################################
c  Sample.f: beta version written by H. Yoshinari and N. Maximenko
c                                                                  (2005/12/16)
c##############################################################################
      implicit real(a-h,o-z)
      implicit integer(i-n)
      parameter(max1=200000)
      parameter(nfloat=3039,nDAC=9,ntype=10)
      real Xndp(max1),Yndp(max1),Zpk(max1),Tndp(max1),Undp(max1),
     &     Vndp(max1),EUndp(max1),EVndp(max1),Xnsf(max1),Ynsf(max1),
     &     Tnsf(max1),Unsf(max1),Vnsf(max1),EUnsf(max1),EVnsf(max1),
     &     Xmlt(max1),Ymlt(max1),Tmlt(max1),Xnft(max1),Ynft(max1),
     &     Tnft(max1),Xnlt(max1),Ynlt(max1),Tnlt(max1)
      integer Nnfx(max1),ID(max1),Cyc(max1),Flg(max1)
      integer WMOID(nfloat),DAC(nfloat),type(nfloat)
      character nmDAC(nDAC)*17,nmtype(ntype)*9
      character chk*1
c--- Open the file: "yomaha05.dat". -------------------------------------------
      open(99,file='yomaha05.dat')
c--- Read the values stored in "yomaha05.dat". --------------------------------
c     ------------------------------
      i=1
      
c---format of yomaha05.dat
199   format(f9.4,f9.4,f7.1,f9.3,4f8.2,f10.4,f9.4,f9.3,4f8.2,
     ,3(f10.4,f9.4,f9.3),2i5,i4,i2)
c     ------------------------------
1       read(99,199,end=49) Xndp(i),Yndp(i),Zpk(i),Tndp(i),Undp(i),
     &        Vndp(i),EUndp(i),EVndp(i),Xnsf(i),Ynsf(i),Tnsf(i),Unsf(i),
     &        Vnsf(i),EUnsf(i),EVnsf(i),Xmlt(i),Ymlt(i),Tmlt(i),Xnft(i),
     &        Ynft(i),Tnft(i),Xnlt(i),Ynlt(i),Tnlt(i),Nnfx(i),ID(i),
     &        Cyc(i),Flg(i)
      i=i+1
      go to 1
c     ------------------------------
 49   ntd = i-1
      close(99)
c--- Open the file: "yomaha2wmo.dat". -----------------------------------------
      open(98,file='yomaha2wmo.dat')
c--- Read the values stored in "yomaha2wmo.dat". ------------------------------
c     ------------------------------
  2     read(98,198,end=3) i,WMOID(i),DAC(i),type(i)
198   format(i4,i8,2i2)
      go to 2
c     ------------------------------
  3      close(98)
c--- Open the file: "DACs.txt". -----------------------------------------------
      open(97,file='DACs.txt')
c--- Read the values stored in "DACs.txt". ------------------------------------
c     ------------------------------
 4      read(97,'(i3,3x,a17)',end=5) i,nmDAC(i)
      go to 4
c     ------------------------------
 5     close(97)
c--- Open the file: "float_types.txt". ----------------------------------------
      open(96,file='float_types.txt')
c--- Read the values stored in "float_types.txt". -----------------------------
c     ------------------------------
 6      read(96,'(i6,3x,a9)',end=7) i,nmtype(i+1)
      go to 6
c     ------------------------------
 7     close(96)
      write(*,*) 'There are ',ntd,' velocity records in "yomaha05.dat".'
 48   continue
      write(*,*) 'Enter the data # you want to see: (1-',ntd,')'
      
      read(*,*) nd
      write(*,*) '____________________________________________________',
     &'_________________'
      write(*,*) '     Record number:............ ',nd
      write(*,*) '     Serial Float ID:.......... ',ID(nd)
      write(*,*) '     Cycle Number:............. ',Cyc(nd)
      write(*,*) '     WMO float ID:............. ',WMOID(ID(ND))
      write(*,*) '     DAC:......................   ',
     &nmDAC(DAC(ID(ND)))
      write(*,*) '     Float Type:...............   ',
     &nmtype(type(ID(ND))+1)
      write(*,*) 'Longitude of deep velocity (DV) estimate:',
     &'..................',Xndp(nd)
      write(*,*) 'Latitude of DV estimate:............',
     &'.......................',Yndp(nd)
      write(*,*) 'Programed parking pressure [dbar]:..',
     &'.......................',Zpk(nd)
      write(*,*) 'Julian day (JD) of DV estimate since',
     &' 2000-01-01 00:00:00 : ',Tndp(nd)
      write(*,*) 'Zonal component of DV [cm/s]:.......',
     &'.......................',Undp(nd)
      write(*,*) 'Meridional component of DV [cm/s]:..',
     &'.......................',Vndp(nd)
      write(*,*) 'Error of zonal component of DV [cm/s]:',
     &'.....................',EUndp(nd)
      write(*,*) 'Error of meridional component of DV [cm/s]:',
     &'................',EVndp(nd)
      write(*,*) '   Longitude of surface velocity (SV) estimate:.',
     &'...',Xnsf(nd)
      write(*,*) '   Latitude of SV estimate:.....................',
     &'...',Ynsf(nd)
      write(*,*) '   JD of SV estimate since 2000-01-01 00:00:00 :',
     &'...',Tnsf(nd)
      write(*,*) '   Zonal component of SV [cm/s]:................',
     &'...',Unsf(nd)
      write(*,*) '   Meridional component of SV [cm/s]:...........',
     &'...',Vnsf(nd)
      write(*,*) '   Error of zonal component of SV [cm/s]:.......',
     &'...',EUnsf(nd)
      write(*,*) '   Error of meridional component of DV [cm/s]:..',
     &'...',EVnsf(nd)
      write(*,*) 'Longitude of last fix of previous cycle:.........',
     &'........... ',Xmlt(nd)
      write(*,*) 'Latitude of last fix of previous cycle:..........',
     &'........... ',Ymlt(nd)
      write(*,*) 'JD of last fix of previous cycle since 2000-01-01',
     &' 00:00:00 : ',Tmlt(nd)
      write(*,*) ' Longitude of first fix of this cycle:.........',
     &'........... ',Xnft(nd)
      write(*,*) ' Latitude of first fix of this cycle:..........',
     &'........... ',Ynft(nd)
      write(*,*) ' JD of first fix of this cycle since 2000-01-01',
     &' 00:00:00 : ',Tnft(nd)
      write(*,*) 'Longitude of last fix of this cycle:.........',
     &'............',Xnlt(nd)
      write(*,*) 'Latitude of last fix of this cycle:..........',
     &'............',Ynlt(nd)
      write(*,*) 'JD of last fix of this cycle since 2000-01-01',
     &' 00:00:00 : ',Tnlt(nd)
      write(*,*) 
     &'Number of fixes at the sea surface in this cycle:....',
     &Nnfx(nd)
      write(*,*) 'Time flag: ',Flg(nd)
      write(*,*) '____________________________________________________',
     &'_________________'
      
c     ------------------------------
      write(*,*) 'Do you want to see the another records? [y/n]'
      read(*,'(a1)') chk
c     ++++++++++++++++++++++++++++++
      if (chk .eq. 'y') then
         go to 48
      end if
c     ++++++++++++++++++++++++++++++
      write(*,*) 'Thanks for using YoMaHa05 dataset.  Bye!'
c
      stop
      end
